<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>36.30</title>
</head>

<body>
    <div class="container">
        
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>

        <div class="btn-addUser">
            <button id="btn-adđ" class="btn btn-success mb-3">Thêm user</button>
        </div>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
       
        onPageLoading();
        //gán sự kiện cho nút sửa
        $("#table-users").on("click", ".edit-user", function(){
            onBtnEditUserClick(this);
        });
        //gán sự kiện cho nút xóa
        $("#table-users").on("click", ".delete-user", function(){
            onBtnDeleteUserClick(this);
        });
        $("#btn-adđ").on("click",onBtnAddClick)
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        loadDataonTable();
    }
    //Hàm gán sự kiện cho nút sửa
    function onBtnEditUserClick(paramEdit){
        var vUserId = $(paramEdit).data("id");
        console.log(vUserId);
        const vDETAIL_FROM_URL = "updateUser.html";
        var vUpToPage = vDETAIL_FROM_URL + "?id=" + vUserId;
        window.location.href = vUpToPage;
    }

    //Hàm gán sự kiện cho nút xóa
    function onBtnDeleteUserClick(paramDelete){
        var vUserId = $(paramDelete).data("id");
        console.log(vUserId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API, load dữ liệu vào table
    function loadDataonTable() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUser) {
                loadUserToTable(paramUser);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    //Hàm load data user vào table
    function loadUserToTable(paramUser) {
        var vUserTable = $("#table-users");
        for (var bI = 0; bI < paramUser.length; bI++) {
            //Tạo dòng
            var bNewRow = $("<tr>").appendTo(vUserTable);
            //tạo ô, gán dữ liệu cho từng ô, gán data vào dòng
            $("<td>", { html: paramUser[bI].id }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].firstname }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].lastname }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].country }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].subject }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].customerType }).appendTo(bNewRow);
            $("<td>", { html: paramUser[bI].registerStatus }).appendTo(bNewRow);
            var bActionCell = $("<td>").appendTo(bNewRow);
            //Nút sửa (tạo nút, gán vào ô bActionCell)
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary edit-user mr-2"
            }).data("id", paramUser[bI].id)
            .appendTo(bActionCell);

            //Nút xóa
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger delete-user"
            }).data("id", paramUser[bI].id)
            .appendTo(bActionCell);
        }
    }
    function onBtnAddClick(){
        "use strict"
        const vINSERT_FROM_URL = "./insertUser.html";
        var vInsertpage = vINSERT_FROM_URL;
        window.location.href = vInsertpage;
    }
</script>

</html>